/*
 * This file is generated by jOOQ.
*/
package com.tabajara.base.tables.daos;


import com.tabajara.base.tables.Usuarios;
import com.tabajara.base.tables.records.UsuariosRecord;

import io.github.jklingsporn.vertx.jooq.shared.internal.AbstractVertxDAO;

import java.util.List;

import javax.annotation.Generated;

import org.jooq.Configuration;


import io.vertx.core.Future;
import io.github.jklingsporn.vertx.jooq.classic.jdbc.JDBCClassicQueryExecutor;
/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.10.5"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class UsuariosDao extends AbstractVertxDAO<UsuariosRecord, com.tabajara.base.tables.pojos.Usuarios, Integer, Future<List<com.tabajara.base.tables.pojos.Usuarios>>, Future<com.tabajara.base.tables.pojos.Usuarios>, Future<Integer>, Future<Integer>> implements io.github.jklingsporn.vertx.jooq.classic.VertxDAO<UsuariosRecord,com.tabajara.base.tables.pojos.Usuarios,Integer> {

    /**
     * @param configuration The Configuration used for rendering and query execution.
     * @param vertx the vertx instance
     */
    public UsuariosDao(Configuration configuration, io.vertx.core.Vertx vertx) {
        super(Usuarios.USUARIOS, com.tabajara.base.tables.pojos.Usuarios.class, new JDBCClassicQueryExecutor<UsuariosRecord,com.tabajara.base.tables.pojos.Usuarios,Integer>(com.tabajara.base.tables.pojos.Usuarios.class,configuration,vertx), configuration);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    protected Integer getId(com.tabajara.base.tables.pojos.Usuarios object) {
        return object.getUsuid();
    }

    /**
     * Find records that have <code>usunome IN (values)</code> asynchronously
     */
    public Future<List<com.tabajara.base.tables.pojos.Usuarios>> findManyByUsunome(List<String> values) {
        return findManyByCondition(Usuarios.USUARIOS.USUNOME.in(values));
    }

    /**
     * Find records that have <code>ususenha IN (values)</code> asynchronously
     */
    public Future<List<com.tabajara.base.tables.pojos.Usuarios>> findManyByUsusenha(List<String> values) {
        return findManyByCondition(Usuarios.USUARIOS.USUSENHA.in(values));
    }

    /**
     * Find records that have <code>usuativo IN (values)</code> asynchronously
     */
    public Future<List<com.tabajara.base.tables.pojos.Usuarios>> findManyByUsuativo(List<String> values) {
        return findManyByCondition(Usuarios.USUARIOS.USUATIVO.in(values));
    }

    /**
     * Find records that have <code>fkfunmatricula IN (values)</code> asynchronously
     */
    public Future<List<com.tabajara.base.tables.pojos.Usuarios>> findManyByFkfunmatricula(List<String> values) {
        return findManyByCondition(Usuarios.USUARIOS.FKFUNMATRICULA.in(values));
    }

    /**
     * Find records that have <code>fkgrpid IN (values)</code> asynchronously
     */
    public Future<List<com.tabajara.base.tables.pojos.Usuarios>> findManyByFkgrpid(List<Integer> values) {
        return findManyByCondition(Usuarios.USUARIOS.FKGRPID.in(values));
    }
}
